string_length:
  ; Search for \0 in a string and determine its length
  ;
  ; PARAMETERS
  ; X - low address of the string
  ; Y - high address of the string
  ;
  ; RETURNS
  ; A - length of the string

  stx STRING_ADDRESS
  sty STRING_ADDRESS + 1

  ; String index
  ldy #0

.loop:
  lda (STRING_ADDRESS), y
  beq .end
  iny

  jmp .loop

.end:
  ; Store string length in A
  tya

  ; Restore Y
  ldy STRING_ADDRESS + 1
  
  rts