
  ; Counter demo
  lda #0
  ldx #0
  ldy #0

loop_count:
  phx
  phy

  ldx #0
  ldy #0
  jsr lcd_goto

  ply
  plx

  jsr lcd_print_debug

  ina
  beq increment_x
  jmp loop_count

increment_x:
  inx
  beq increment_y
  jmp loop_count

increment_y:
  iny
  jmp loop_count

; Rx demo
; rx_loop:
;   ldx #0
;   ldy #0
;   jsr lcd_goto

;   jsr uart_recv
;   jsr lcd_print_accumulator

;   jmp rx_loop

  ; .include "HD44780.s"
  ; .include "variables.s"


; PS/2 demo
; PS/2 registers
PS2_STATUS_REGISTER = $6D00
PS2_DATA_REGISTER   = $6D01

irq:
  pha
  phx
  phy

  ldx #0
  ldy #0
  jsr lcd_goto

  lda PS2_STATUS_REGISTER
  and #%11100000
  jsr to_hex
  jsr lcd_print_string

  lda #" "
  jsr lcd_write_data

  lda PS2_DATA_REGISTER
  jsr to_hex
  jsr lcd_print_string

  tax

  lda #" "
  jsr lcd_write_data

  lda scancodes, x
  jsr to_hex
  jsr lcd_print_string

  tax
  lda #" "
  jsr lcd_write_data
  txa

  jsr lcd_write_data
  
  ply
  plx
  pla
  rti

; Print debug
  phx
  phy
  ldx #0
  ldy #1
  jsr lcd_goto
  ply
  plx
  jsr lcd_print_debug

  ; phy
  ; phx  
  ; ldx #<str_mloop
  ; ldy #>str_mloop
  ; jsr uart_print_string
  ; jsr to_hex
  ; jsr uart_print_string
  ; plx
  ; ply

  .loop_end:
; Debug printing arguments (SHELL)
;   ; -----------------------
;   ; Arg count
;   ldx #<str_arguments
;   ldy #>str_arguments
;   jsr uart_print_string

;   lda SHELL_ARGUMENT_COUNT
;   jsr to_hex
;   jsr uart_print_string

;   asl   ; Shift left once (mul by 2)
;   sta SHELL_ARGUMENT_COUNT

;   lda #"\n"
;   jsr uart_send

;   ; -----------------------
;   ; Print args

;   ; X - index to the pointer array
;   ldx #0

; .ptr_loop:
;   cpx SHELL_ARGUMENT_COUNT
;   beq .ptr_loop_end

;   lda SHELL_TOKEN_POINTERS, x   ; Load A with low address
;   inx

;   ldy SHELL_TOKEN_POINTERS, x   ; Load Y with high address
;   inx

;   phx                             ; Save X on stack
;   tax                             ; A -> X (low address)

;   jsr uart_print_string
;   plx

;   lda #"\n"
;   jsr uart_send

;   jmp .ptr_loop

; .ptr_loop_end:
;   ldx #<str_done
;   ldy #>str_done
;   jsr uart_print_string
